

# Main

$fh_count = -1;
$template_file = "main_template.tpl";
$next_line = "***********\n";

while ( &get_next_line(*fh_count, *_) )
{
#  $rc = &get_next_line(*next_line);
#  print "Return code = $rc\n";
#  if ( $rc == 0 )
#  {
#     exit;
#  }
#  else
#  {
      print $_;
#  }
}


sub get_next_line
{
   local ( *g100_fh_count, *next_line ) = @_;
   local ( $exp_filehandle, $return_code );
   local ( $dummy, $inc_file_name );

   # Is this the first file we are reading from?
   if ( $g100_fh_count == -1 )
   {
      $exp_filehandle = "INCL_TEMPLATE_".++$g100_fh_count;
      open( $exp_filehandle, $template_file )
         || die "Cannot open template file \"$template_file\" for input: $!\n";
   }
   else
   {
      # Set filehandle to current value.
      $exp_filehandle = "INCL_TEMPLATE_".$g100_fh_count;
   }

   # Is this the last line of this file?
   if ( eof($exp_filehandle) )
   {
      # If this is the last or only file on the stack, we are all done.
      close( $exp_filehandle );
      return(0)  if ( --$g100_fh_count == -1 );

      # Not done -- go back to the previous file and keep reading.
      $return_code = &get_next_line( *g100_fh_count, *next_line );
   }
   else
   {
      $next_line = <$exp_filehandle>;
      $return_code = 1;
   }

   # Is this line an INCLUDE statement?
   if ( $next_line =~ /^\s*\$\$INCLUDE\s+/ )
   {
      chop ( $next_line );
      ( $dummy, $inc_file_name ) = split( /^\s*\$\$INCLUDE\s+/, $next_line );

      $exp_filehandle = "INCL_TEMPLATE_".++$g100_fh_count;
      open( $exp_filehandle, $inc_file_name )
         || die "Cannot open include file \"$inc_file_name\": $!\n";
      $return_code = &get_next_line( *g100_fh_count, *next_line );
   }

   # If we got this far, we have a line to return.
   return($return_code);
}
