#!/bin/csh
#
#  route_flush.csh
#
#    NOTES:
#       1.  You must be root to run this file.
#       2.  The list of default routes to re-install is system-specific.
#
set mach_type=`arch`
if ( $mach_type == "sun4" ) then
   route -f
   route add default         198.108.60.1      1
   route add 192.168.10.0    198.108.60.244    2
else
   if ( $mach_type == "i386" ) then
      route flush; route add default 192.168.10.1
   else
      echo "**** Unsupported machine type"
   endif
endif
#
