


export proto idrp rdi $$PEER_RDI
{
       proto idrp rdi $PEER_1
       idrp-ps-policy-atts 
       {
               route-server restrict;
               hierarch-rec;
               multiexit >= 25;
               rd-transit-delay <= 500;
               expense < 5;
       }
       idrp-ps-atts 
       {
               route-server on;
               hierarch-rec;
               rd-transit-delay 97;
               rdlre 125;
               expense 12;
               priority 3;
               capacity 15;
	# here's where I need to specify variables
	#
               allow-dist { $RDI_EXPORT_LIST_ALLOW };
               prohibit-dist { $RDI_EXPORT_LIST_PROHIBIT };
       }
       {
               ip 128.80;
               ip 128.81;
               ip 128.82;
               ip 128.83;
       };

	proto static
	{
		ip all;
		all;
	}
};




